image: docker:19.03.1

services:
  - docker:19.03.1-dind
  
stages:
  - build
  - deploy


variables:
  # Use TLS https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#tls-enabled
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"
  CI_REGISTRY_IMAGE_TAG: ${CI_COMMIT_REF_SLUG}_${CI_COMMIT_SHORT_SHA}_${CI_PIPELINE_ID}

before_script:
  - export CI_JOB_TIMESTAMP=$(date --utc "+%Y%m%dT%H%M%S")


build:
  stage: build
  script:
    - echo $CI_REGISTRY_IMAGE_TAG
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_REGISTRY_IMAGE_TAG --tag $CI_REGISTRY_IMAGE:latest .
    - docker push $CI_REGISTRY_IMAGE:$CI_REGISTRY_IMAGE_TAG
    - docker push $CI_REGISTRY_IMAGE:latest

deploy:
  image:
    name: grzesrap/tools:v3
    entrypoint: [""]
  environment:
    name: prep
    kubernetes:
      namespace: freshmail
  stage: deploy
  variables:
    CI_APP_NAME: demo-freshmail
  script:
    - kubectl get pods
    - kubectl set image deployment/${CI_APP_NAME} app=${CI_REGISTRY_IMAGE}:${CI_REGISTRY_IMAGE_TAG}
    - if ! kubectl rollout status deployment $CI_APP_NAME; then
        kubectl rollout undo deployment $CI_APP_NAME;
        kubectl rollout status deployment $CI_APP_NAME;
        exit 1;
      fi
    - echo 'Rollout completed'
